#!/usr/bin/perl

# 2003-11-08 programmeerimisvistluse 3. lesande tester
# lesanne: FAIL CRONTAB
# Autor: Heno Ivanov

use Date::Manip;

$ENV{TZ} = 'UTC';


$startdate = &ParseDate($ARGV[1]);
$enddate = &ParseDate($ARGV[2]);


open(F,$ARGV[0]);


$nrows = 0;

while (<F>) {
	my ($min,$tund,$paev,$kuu,$nadal,$cmd) = m|^([\w,\-*]+)\s+([\w,\-*]+)\s+([\w,\-*]+)\s+([\w,\-*]+)\s+([\w,\-*]+)\s+(.*$)|;

#	print "min=$min\n";
#	print "tund=$tund\n";
#	print "paev=$paev\n";
#	print "kuu=$kuu\n";
#	print "nadal=$nadal\n";

#	print "cmd=$cmd\n";
	$$crontab[$nrows]{min} = $min;
	$$crontab[$nrows]{tund} = $tund;
	$$crontab[$nrows]{paev} = $paev;
	$$crontab[$nrows]{kuu} = $kuu;
	$$crontab[$nrows]{nadal} = $nadal;
	$$crontab[$nrows]{cmd} = $cmd;
	$nrows++;
}

close(F);

$cdate = $startdate;
$cdate = &DateCalc($cdate, "-1 minute");

while (Date_Cmp($cdate,$enddate) <= 0 ) {
#	print &UnixDate($cdate,"%d.%m.%Y %H:%M\n");	
	$cdate = &DateCalc($cdate, "+1 minute");


	foreach $i (0..($nrows - 1 )) {
		dojob($cdate,$$crontab[$i]);
	}
}


sub dojob {
	my ($cdate, $crontab) = @_;
	$cpaev = &UnixDate($cdate,"%d");
	$cnadal = &UnixDate($cdate,"%w") % 7;
#	print &UnixDate($cdate,"%d.%m.%Y %H:%M -MARK-\n");

	if ((!checkrange($cnadal,$$crontab{nadal},0,6)) && ($$crontab{paev} eq "*"))  { return 0; }
	if ((!checkrange($cpaev,$$crontab{paev},1,31)) && ($$crontab{nadal} eq "*")) { return 0; }
	if (((!checkrange($cnadal,$$crontab{nadal},0,6)) && !checkrange($cpaev,$$crontab{paev},1,31))) { return 0; }

	$ckuu = &UnixDate($cdate,"%m");
	if (!checkrange($ckuu,$$crontab{kuu},1,12)) { return 0; }

	$ctund = &UnixDate($cdate,"%H");
	if (!checkrange($ctund,$$crontab{tund},0,23)) { return 0; }

	$cmin = &UnixDate($cdate,"%M");
	if (!checkrange($cmin,$$crontab{min},0,59)) { return 0; }




	print &UnixDate($cdate,"%d.%m.%Y %H:%M $$crontab{cmd}\n");
}


sub checkrange {
	my ($cval,$cron,$min,$max) = @_;

	if ($cron eq "*") {
		return 1;
	} else {
		foreach $j (split(',',$cron)) {
			if ($j =~ /\-/) { # range
				my ($c1,$c2) = split(/-/,$j);
#				print "DEB: $c1 $c2 \n";
				if (($c1 < $min) || ($c1 > $max)) { die "crontab error"; }
				if (($c2 < $min) || ($c2 > $max)) { die "crontab error"; }
				if ($c1 > $c2) { die "crontab error" }
				if (($cval >= $c1 ) && ($cval <= $c2)) {
					return 1;
				}
	
			} else {
				if (($j < $min) || ($j > $max)) { die "crontab error"; }
				if ($j == $cval) {
					return 1;
				}
			}
		} }

	return 0;
}
