{ 2003-11-08 programmeerimisvistluse algajate 1. lesande lahendus         }
{ lesanne: JADA                                                            }
{ Autor: Ahto Truu                                                          }
{ Testitud: FPC 1.0.6 / Win32, TPC 6.0                                      }

{ Kuna Turbo Pascal ei vimaldada kasutada le 64K staatilisi andmeid,      }
{ peame selles lahenduses jada hoidma osade kaupa. Jada hoiame maxt         }
{ tkina, iga tki pikkus maxp elementi. Tki t element p hoiab algse       }
{ jada elementi number (t - 1) * maxp + p.                                  }

const
   sisf = 'JADA.SIS';                                    { sisendfaili nimi }
   valf = 'JADA.VAL';                                   { vljundfaili nimi }
   maxn = 100000;                                 { maksimaalne jada pikkus }
   maxt = 10;                                            { jada tkkide arv }
   maxp = 10000;                                { elementide arv hes tkis }
                                    { NB! peab kehtima: maxn <= maxt * maxp }

type
   tykk = array [1..maxp] of longint;          { jada tkk, mis on alla 64K }

var
   n : longint;                                               { jada pikkus }
   a : array [1..maxt] of ^tykk;                               { jada tkid }
   f : text;                          { failimuutuja sisendi-vljundi jaoks }
   i : longint;                                   { jooksva elemendi indeks }
   x : longint;                                  { jooksva elemendi vrtus }
   s : longint;                                               { sammude arv }

{ salvestab elemendi i vrtuse x igesse tkki }
procedure pane(i, x : longint);
var t, p : longint;
begin
   { leiame sellised t ja p, et (t - 1) * maxp + p = i }
   t := (i - 1) div maxp + 1;
   p := (i - 1) mod maxp + 1;
   { salvestame elemendi vrtuse }
   a[t]^[p] := x;
end;

{ loeb elemendi i vrtuse igest tkist }
function vota(i : longint) : longint;
var t, p : longint;
begin
   { leiame sellised t ja p, et (t - 1) * maxp + p = i }
   t := (i - 1) div maxp + 1;
   p := (i - 1) mod maxp + 1;
   { tagastame elemendi vrtuse }
   vota := a[t]^[p];
end;

begin
   { eraldame tkkidele mlu }
   for i := 1 to maxt do
      new(a[i]);

   { loeme sisendandmed }
   assign(f, sisf); reset(f);
   readln(f, n);
   for i := 1 to n do begin
      read(f, x);
      pane(i, x);
   end;
   readln(f);
   close(f);

   { loendame sammude arvu }
   i := 1;                                  { alustame esimesest elemendist }
   s := 0;                                      { seni oleme teinud 0 sammu }
   repeat
      i := vota(i);                         { liigume jrgmisele elemendile }
      s := s + 1;                                   { loendame tehtud sammu }
   until (i = 1) or (s = n);

   { vljastame vastuse }
   assign(f, valf); rewrite(f);
   if i = 1 then begin
      { judsime algusse tagasi, jaatav vastus }
      writeln(f, 'JAH');
      writeln(f, s);
   end else begin
      { ei judnud algusse tagasi, eitav vastus }
      writeln(f, 'EI');
   end;
   close(f);

   { vabastame mlu }
   for i := 1 to maxt do
      dispose(a[i]);
end.
